#!/usr/bin/perl -W

# this is quite kludgy solution
# - I hate doing things of this kind in perl.
# Hope, Linux users know what to do.
#
# SMBC Hacker

use strict;
use warnings;
use Socket;
use Carp;

sub spawn; # forward declaration
sub logmsg { print "$0 $$: @_ at ", scalar localtime, "\n" }

my $buflen = 4096;
my %contenttypes = (
  'gz'  => 'application/x-gzip',
  'swf' => 'application/x-shockwave-flash',
  'xml' => 'application/xml',
  'htm' => 'text/html',
  'html' => 'text/html'
);

my $port = 80;
my $proto = getprotobyname('tcp');

socket (Server, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";

setsockopt (Server, SOL_SOCKET, SO_REUSEADDR, pack('l', 1)) || die "setsockopt: $!";

bind (Server, sockaddr_in($port, INADDR_LOOPBACK)) || die "bind: $!";

listen (Server, SOMAXCONN) || die "listen: $!";

my $waitedpid = 0;
my $paddr;

use POSIX ":sys_wait_h";
sub REAPER {
  my $child;
  while (($waitedpid = waitpid(-1, WNOHANG)) > 0) {
    logmsg "reaped $waitedpid".($? ? " with exit $?":'');
  }
  $SIG{CHLD} = \&REAPER;
}

$SIG{CHLD} = \&REAPER;

for ( $waitedpid = 0;
      ($paddr = accept(Client, Server)) || $waitedpid;
      $waitedpid = 0, close Client)
{
  next if $waitedpid and not $paddr;
  my ($port, $iaddr) = sockaddr_in($paddr);
  my $name = gethostbyaddr($iaddr, AF_INET);
  logmsg "connection from $name [", inet_ntoa($iaddr), "] at port $port";

  spawn sub { ### SERVER PRORGAM STARTS HERE #################################
    $|=1;

    my ($method, $url, $httpver);

    confess "something was wrong with request headers"
      unless (<Client> =~ /^(\S+) (\S+) (\S+)\r$/);

    $method = $1;
    $url = $2;
    $httpver = $3;

    # I think we can put client's headers in trash

    while (<Client> =~ /^(.+)\r$/) {};

    if ($url =~ /\/([^\/]+)$/)
    {
      my $filename = $1;
      if (-e $filename)
      {
        my $ext = ($filename =~ /\.(.+)$/) ? $1 : '';
        my $ct = (exists $contenttypes{$ext}) ? $contenttypes{$ext} : 'application/octet-stream';
        my $bytes = -s $filename;

        open FILE, $filename || confess "Could not open file $filename";

        print Client "$httpver 200 OK\r\nContent-Type: $ct\r\nContent-Length: $bytes\r\n\r\n";

        my $buffer;

        while ($bytes > $buflen)
        {
          sysread FILE, $buffer, $buflen;
          print Client $buffer;
          $bytes -= $buflen;
        }

        sysread FILE, $buffer, $bytes;
        print Client $buffer;
      }
      else
      {
        print Client "$httpver 404 Not Found\r\n\r\n";
      }
    }
    else
    {
      print Client "$httpver 301 Moved Permanently\r\nLocation: SmbcPreloader.swf\r\nContent-Length: 0\r\n\r\n";
    }
  }; #########################################################################
}

sub spawn {
  my $coderef = shift;

  unless (@_ == 0 && $coderef && ref($coderef) eq 'CODE') {
    confess "usage: spawn CODEREF";
  }

  my $pid;
  if (!defined($pid = fork)) {
    logmsg "cannot fork: $!";
    return;
  } elsif ($pid) {
    logmsg "begat $pid";
    return; # I'm the parent
  }

  exit &$coderef();
}